<?php

class plgHikashoppaymentCashbill extends hikashopPaymentPlugin
{
var $accepted_currencies = array('PLN');

var $multiple = true;
var $name = 'cashbill';
var $doc_form = 'cashbill';
var $pluginConfig = array(
    'user_id' => array("Identyfikator Punktu Płatności",'input'),
    'user_key' => array("Klucz Punktu Płatności",'input'), 
    'return_url' => array('Adres powrotu przeglądarki', 'html',''), 
    'notify_url' => array('Adres serwerowego potwierdzenia transakcji','html',''), 
    'invalid_status' => array('Status błędnej transakcji', 'orderstatus'), 
    'verified_status' => array('Status poprawnej transakcji', 'orderstatus')
);


    function __construct(&$subject, $config) {
        parent::__construct($subject, $config);
        
        $this->pluginConfig['return_url'][2] = HIKASHOP_LIVE."index.php?option=com_hikashop&ctrl=checkout&task=after_end";
        $this->pluginConfig['notify_url'][2] = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&amp;notif_payment='.$this->name.'&tmpl=component';
        
    }

    function onBeforeOrderCreate(&$order,&$do){
        if(parent::onBeforeOrderCreate($order, $do) === true)
            return true;
    
        if(empty($this->payment_params->user_id) || empty($this->payment_params->user_key)) {
            $this->app->enqueueMessage('Konfiguracja wtyczki CashBill nie jest uzupełniona poprawnie');
            $do = false;
        }
    }

    function onAfterOrderConfirm(&$order, &$methods, $method_id) {
        parent::onAfterOrderConfirm($order, $methods, $method_id);
        $amount = round($order->cart->full_total->prices[0]->price_value_with_tax,2);
        $amount = number_format($amount, 2, '.', '');
        $hidden = array(
            'service'=>$this->payment_params->user_id,
            'amount'=>$amount,
            'currency' => "PLN",
            'desc'=>'Zamówienie nr : '.$order->order_id,
            'lang' => "",
            'userdata'=>$order->order_id,
            'ref'=>'HikaShop',
            'forname'=> $order->cart->billing_address->address_firstname,
            'surname'=> $order->cart->billing_address->address_lastname,
            'email'=>$this->user->user_email,
            'tel' => "",
            'street'=>$order->cart->billing_address->address_street,
            'street_n1' => "",
            'street_n2' => "",
            'city'=>$order->cart->billing_address->address_city,
            'postcode'=>$order->cart->billing_address->address_post_code,
            'country' => "",
        );
        
        $sign = md5(implode("|",$hidden).'|'.$this->payment_params->user_key);
        $hidden['sign'] = $sign;
        $this->vars = $hidden;
        return $this->showPage('end');
    }

    function checkSignature($data,$key,$sign){
        if(md5($data['service'].$data['orderid'].$data['amount'].$data['userdata'].$data['status'].$key) === $sign){
            return true;
        }

        if(md5($data['service'].'|'.$data['orderid'].'|'.$data['amount'].'|'.$data['userdata'].'|'.$data['status'].'|'.$key) === $sign){
            return true;
        }

        return false;
    }

    function onPaymentNotification(&$statuses) {
        $pluginsClass = hikashop::get('class.plugins');
        $plugin = $pluginsClass->getMethods('payment','cashbill');
        $plugin = reset($plugin);
        
    
    if($this->checkSignature($_POST,$plugin->payment_params->user_key,$_POST['sign']))
    {
        
    	$orderClass = hikashop::get('class.order');
		$dbOrder = $orderClass->get($_POST['userdata']);
		
		$order = new stdClass();
		$order->history = new stdClass();
		$order->old_status = new stdClass;
		$order->order_id = $dbOrder->order_id;
		$order->old_status->order_status=$dbOrder->order_status;
		$order->history->history_type = 'payment';
		$order->history->history_reason='Powiadomienie z serwera CashBill';
		$order->history->history_notified=0;
		$order->history->history_amount=$_POST['amount'].'PLN';
		$order->history->history_payment_id = $plugin->payment_id;
		$order->history->history_payment_method =$plugin->payment_type;
		if(strtoupper($_POST['status']) == 'OK')
		{
		$order->history->history_data = 'Przyjęcie płatności w kwocie '.$_POST['amount'].' PLN przez CashBill.pl';
		    
	    $order->order_status = $plugin->payment_params->verified_status; 		    
		}
		if(strtoupper($_POST['status']) == 'ERR')
		{
		$order->history->history_data = 'Płatność nie została przyjęta ID CashBill : '.$_POST['orderid']; 
		$order->order_status = $plugin->payment_params->invalid_status;
		}
		$order->history->history_notified = 1;
		$orderClass->save($order);
		echo 'OK';
		exit();
    }		
    echo 'BLAD SYGNATURY';		
    exit();
    }
    
    function onPaymentConfiguration(&$element) {
        parent::onPaymentConfiguration($element);
    
    }
    
    function onPaymentConfigurationSave(&$element) {
    
        return true;
    }
    
    function getPaymentDefaultValues(&$element) {
        $element->payment_name = 'CashBill';
        $element->payment_description='Płatności CashBill w Twoim sklepie HikaShop.';
    
        $element->payment_params->user_id = '';
        $element->payment_params->user_key = '';
        $element->payment_params->invalid_status = 'cancelled';
        $element->payment_params->verified_status = 'confirmed';
    }
    
}

?>